//app.js
import $api from './utils/api'
import {
  BASEIMGURL,
  BASEIMGURL1
} from './utils/config';


import GlobalConfig from './config/index'

const globalConfig = new GlobalConfig()

globalConfig.init()
App({
  onLaunch() {
    console.log('v1.0')
    const that = this;
    wx.getSystemInfo({
      success:function(res){
        that.globalData.systemInfo = res;
      }
    })
    if (wx.canIUse('getUpdateManager')) {
      const updateManager = wx.getUpdateManager()
      updateManager.onCheckForUpdate(function (res) {
        if (res.hasUpdate) {
          updateManager.onUpdateReady(function () {
            wx.showModal({
              title: '更新提示',
              content: '新版本已经准备好，是否重启应用？',
              success: function (res) {
                if (res.confirm) {
                  updateManager.applyUpdate()
                }
              }
            })
          })
          updateManager.onUpdateFailed(function () {
            wx.showModal({
              title: '已经有新版本了哟~',
              content: '新版本已经上线啦~，请您删除当前小程序，重新搜索打开哟~'
            })
          })
        }
      })
    } else {
      wx.showModal({
        title: '提示',
        content: '当前微信版本过低，无法使用该功能，请升级到最新微信版本后重试。'
      })
    }
    this.getUserLocation();
    // 登录
    wx.login({
      success: res => {
        // 发送 res.code 到后台换取 openId, sessionKey, unionId
        this.globalData.api.getOpenid({
          code: res.code
        }).then(res => {
          this.globalData.userInfo = res.data
          wx.setStorageSync('openid', res.data.openid)
          // 由于 getUserInfo 是网络请求，可能会在 Page.onLoad 之后才返回
          // 所以此处加入 callback 以防止这种情况
          if (this.userInfoReadyCallback) {
            this.userInfoReadyCallback(res.data)
          }
        })
      }
    });

    

    // 获取用户信息
    // wx.getSetting({
    //   success: res => {
    //     if (res.authSetting['scope.userInfo']) {
    //       // 已经授权，可以直接调用 getUserInfo 获取头像昵称，不会弹框
    //       wx.getUserInfo({
    //         success: res => {
    //           // 可以将 res 发送给后台解码出 unionId
    //           this.globalData.userInfo = res.userInfo

    //           // 由于 getUserInfo 是网络请求，可能会在 Page.onLoad 之后才返回
    //           // 所以此处加入 callback 以防止这种情况
    //           if (this.userInfoReadyCallback) {
    //             this.userInfoReadyCallback(res)
    //           }
    //         }
    //       })
    //     }
    //   }
    // })
  },
  // 获取用户位置
  getUserLocation() {
    let _this = this
    wx.getLocation({
      altitude: 'altitude',
      type: 'gcj02',
      success: function (res) {
        // const userLocation = {
        //   longitude: res.longitude,
        //   latitude: res.latitude
        // }
        // _this.globalData.userLocation = userLocation
        // _this.globalData.refuse_position = false
      },
      fail() {}
    })
  },
  onShareAppMessage() {
    const openid = wx.getStorageSync('openid')
    let param = openid && typeof openid === 'string' ? `pages/index/index?openid=${ openid }` : `pages/index/index`
    return {
      title: '点一杯咖啡，聚一簇伙伴，聊一片天地',
      desc: '快来参加活动吧～',
      // imageUrl: 'https://cirraybucket.oss-cn-shanghai.aliyuncs.com/nowwa-h5/aboutUs/share.jpg',
      path: param
    }
  },
  globalData: {
    userInfo: null,
    api: $api,
    openid: '',
    BASEIMGURL,
    BASEIMGURL1,
    shareOpenId: '', //是否是分享进入
    config: globalConfig,
    imgList: [],
    systemInfo:{}
  }
})